﻿Public Class Meigara

    Dim Xcnt As Integer '画面横方向中央
    Dim Ycnt As Integer '画面縦方向中央
    Dim Cntr As Integer '画面の横中央
    Dim a, b As Integer 'セル番号計算用係数

    Private Sub Meigara_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Beep()

        Me.Left = Screen.PrimaryScreen.Bounds.Left : Me.Width = Screen.PrimaryScreen.Bounds.Width
        Me.Top = Screen.PrimaryScreen.Bounds.Top : Me.Height = Screen.PrimaryScreen.Bounds.Height
        Z5lft = (Me.Width - Z5wid) / 2 : Z5top = (Me.Height - Z5hgt) / 2
        Me.Text = Tit

        DGwid = Z5wid : DGhgt = Z5hgt - 88
        DataGridView1.Width = DGwid : DataGridView1.Height = DGhgt
        DGlft = Z5lft : DGtop = Z5top + 30
        DataGridView1.Left = DGlft : DataGridView1.Top = DGtop

        Button1.Width = 180 : Button1.Height = 30
        Button2.Width = 180 : Button2.Height = 30
        Button3.Width = 180 : Button3.Height = 30
        Button4.Width = 180 : Button4.Height = 30

        BTtop = DGtop + DGhgt + 9 : Cntr = Me.Width / 2
        Button1.Top = BTtop : Button1.Left = Cntr + 210
        Button2.Top = BTtop : Button2.Left = Cntr - 390
        Button3.Top = BTtop : Button3.Left = Cntr - 190
        Button4.Top = BTtop : Button4.Left = Cntr + 10

        Label1.Left = Z5lft : Label1.Top = Z5top + 5
        Label2.Left = Z5lft + 563 : Label2.Top = Z5top + 8
        Label3.Left = Z5lft + 120 : Label3.Top = Z5top + 8

        TextBox1.Left = Z5lft + 740 : TextBox1.Top = Z5top + 2

        Call MEIGARA_INP() : MEIGARA_LIST()

    End Sub

    Private Sub dataGridView1_CellClick(ByVal sender As Object, ByVal e As DataGridViewCellEventArgs) Handles DataGridView1.CellClick
        x = DataGridView1.CurrentCell.ColumnIndex()
        y = DataGridView1.CurrentCell.RowIndex
        Napp = 10 * y + x + 1
        TextBox1.Text = Str(Napp) + ") " + Str(Cod0(Napp)) + " " + Mei0(Napp)
    End Sub

    Public Sub MEIGARA_INP()
        '++++++++++++++++
        ' 銘柄名のの入力
        '++++++++++++++++
        Dim CurDir As String
        CurDir = My.Computer.FileSystem.CurrentDirectory
        FileOpen(2, CurDir + "\TOSALL.MEI", OpenMode.Input)

        Input(2, ss)
        n = 0
        Do Until EOF(2)
            n = n + 1
            Input(2, Cod0(n))
            Input(2, Gyo0(n))
            Input(2, t)
            Input(2, Tai0(n))
            Input(2, Tni0(n))
            Input(2, Mei0(n))
        Loop
        FileClose(2)
        Nmei = n
    End Sub

    Public Sub MEIGARA_LIST()
        '++++++++++++++++++
        ' 銘柄リストの表示
        '++++++++++++++++++
        DataGridView1.ColumnCount = 10
        nn = Int((n - 1) / 10)
        DataGridView1.RowCount = nn + 1
        DataGridView1.Font = New Font("MS 明朝", 6.8)
        DataGridView1.RowHeadersWidth = 4
        For i = 0 To 9
            DataGridView1.Columns(i).Width = 84
            DataGridView1.Columns(i).Name = "      " + Str(i + 1)
        Next
        For i = 1 To Nmei
            ii = (i - 1) Mod 10 : jj = ((i - 1) \ 10)
            DataGridView1.Item(ii, jj).Value = Cod0(i) & " " & Mei0(i)
        Next

        Label1.Text = "銘柄数＝" + Str(Nmei)
        Label2.Text = "現在指定している銘柄　→→→"

        x = (Napp - 1) Mod 10
        y = (Napp - 1) \ 10
        DataGridView1.CurrentCell = DataGridView1(x, y) '現在指定中の銘柄
        TextBox1.Text = Str(Napp) + ") " + Str(Cod0(Napp)) + " " + Mei0(Napp)

    End Sub

    Private Sub GETDAY()
        '++++++++++++++++++++++++++++++++++
        ' パンのデータベースから日足を採取
        '++++++++++++++++++++++++++++++++++
        Dim DatePos As Long

        ss = CStr(Year0) + "/1/1"
        ReadBegin = Calen.DatePosition(ss, 1)
        ss = Str(Year9) + "/12/31"
        ReadEnd = Calen.DatePosition(ss, -1)
        Cod = Cod0(Napp) : Mei = Mei0(Napp)
        Price.Read(Cod)
        i = 0 : j = 0 : n = 0
        For DatePos = ReadBegin To ReadEnd
            ss = Calen.Date(DatePos)
            Try
                bl = Price.IsClosed(DatePos)
                If bl = False Then
                    i = i + 1 ': Debug.WriteLine("i = " & i)
                    Dt(i) = Val(Mid(ss, 3, 2) + Mid(ss, 6, 2) + Mid(ss, 9, 2))

                    St(i) = Price.Open(DatePos)
                    Hi(i) = Price.High(DatePos)
                    Lo(i) = Price.Low(DatePos)
                    En(i) = Price.Close(DatePos)
                    Dk(i) = Price.Volume(DatePos)
                    Zo(i) = Price.ExRights(DatePos)
                End If
            Catch ex As Exception
            End Try
        Next
        Nkab = i : Mul = 1
        For i = Nkab To 1 Step -1
            St(i) = Mul * St(i) : Hi(i) = Mul * Hi(i) : Lo(i) = Mul * Lo(i) : En(i) = Mul * En(i)
            If Zo(i) <> 1 Then Mul = Mul * Zo(i)
        Next
        For i = 2 To Nkab
            't = Dk(i - 1) : t0 = Dk(i)
            If Dk(i) = 0 Then
                St(i) = St(i - 1) : Hi(i) = Hi(i - 1) : Lo(i) = Lo(i - 1) : En(i) = En(i - 1)
            End If
        Next
    End Sub

    Private Sub MOVMAV()
        'Pknd=1:Envelope, Pknd=2:Bollinger, Pknd=22:Spwave
        '-----------------------------------------------
        ' 移動日数DMOVの算術移動平均の計算
        ' 直前の増資による修正中に，再増資はないものとする
        '-----------------------------------------------
        ' KST   : 計算開始データ番号 (in)
        ' KEN   : 計算終了データ番号 (in)
        ' DMOV  : 移動日数（指定）   (in)
        ' NKAB  : 立ち会い日数      (in)
        ' EN()  : 終値              (in)
        ' ZO()  : 増資係数          (in)
        ' MAV() : 算術移動平均      (out)
        ' MKR() : 乖離率            (out)
        '-------------------------------------------------
        Dim Tot As Single
        Tot = 0
        For i = 1 To Dtmp - 1
            MAV(i) = -9999 : MKR(i) = -9999
            t = En(i)
            Tot = Tot + En(i)
        Next
        For i = Dtmp To Nkab
            t = En(i)
            Tot = Tot + En(i)
            MAV(i) = Tot / Dtmp : MKR(i) = 100 * (En(i) - MAV(i)) / MAV(i)
            t = MAV(i) : tt = MKR(i)
            t = En(i - Dtmp + 1)
            Tot = Tot - En(i - Dtmp + 1)
        Next
    End Sub

    Private Sub CALSIG() 'Pknd=2:Bollinger
        '-----------------------------------
        ' 移動日数DMOVE日の終値標準偏差を計算
        '-----------------------------------
        ' DMOV  : 移動日数（指定）(in)
        ' NKAB  : 立ち会い日数    (in)
        ' EN()  : 終値           (in)
        ' MAV() : 移動平均       (in)
        ' SIG() : 標準偏差       (out)
        '-------------------------------------
        Dim Tot, Sxx As Single
        i = 1
        Do While MAV(i) = -9999
            Sig(i) = -9999
            i = i + 1
        Loop
        i9 = i
        For i = i9 + 1 To Nkab
            If En(i - 1) > 0 And En(i) = -9999 Then
                En(i) = En(i - 1)
            End If
        Next
        i0 = i9 - Dmov + 1
        Tot = 0 : Sxx = 0
        For i = i0 To i9
            Tot = Tot + En(i)
            Sxx = Sxx + En(i) * En(i)
        Next
        Sig(i9) = Math.Sqrt((Sxx + MAV(i9) * MAV(i9) - (Tot + MAV(i9)) * (Tot + MAV(i9)) / (Dmov + 1)) / Dmov)
        For i = i9 + 1 To Nkab
            Tot = Tot - En(i - Dmov) + En(i)
            Sxx = Sxx - En(i - Dmov) * En(i - Dmov) + En(i) * En(i)
            Sig(i) = Math.Sqrt((Sxx + MAV(i) * MAV(i) - (Tot + MAV(i)) * (Tot + MAV(i)) / (Dmov + 1)) / Dmov)
        Next
    End Sub

    Public Sub TNTSPR() 'Pknd=3:Parabolic, Pknd=22:Spwave
        Dim Pup, Pdn, Min, Max As Single
        Dim Imin, Imax, Sa
        '+++++++++++++++++++++++++++++++++++++++++
        ' ＳＰ波動率による終値折れ線の天底判定
        '+++++++++++++++++++++++++++++++++++++++++
        ' Sppc   : ＳＰ波動率          (in)
        '          ％ではなく，全体を１とした比率
        ' Kst    : 検討開始立会日番号   (in)
        ' Ken    : 検討終了立会日番号   (in)
        ' St()   : 始値                (in)
        ' En()   : 終値                (in)
        ' Ntnt   : 天底数              (out)
        ' Minx() : 天底値              (out)
        ' Imnx() : 天底立会日番号      (out)
        ' Jmnx() : 天底決定立会日番号  (out)
        ' Pup    : ＳＰ上昇率下限      (.)
        ' Pdn    : ＳＰ下降率上限      (.)
        ' ind    : 現在の天底indicator (.)
        '        -1)天底未定, 0)底, 1)天井
        ' Ind0   : 最初の天底の別      (out)
        '+++++++++++++++++++++++++++++++++++++++++
        i = Kst
        Do Until En(i) > 0
            i = i + 1
        Loop
        '
        Pup = (2 + Sppc) / (2 - Sppc)
        Pdn = 1 / Pup
        Min = En(i)
        Max = En(i)
        Imin = i
        Imax = i
        Ntnt = 0
        ind = -1
        '
        For Ikab = i + 1 To Ken
            t = ind
            If En(Ikab) <= 10 Then '倒産銘柄を除外する処理
                En(Ikab) = En(Ikab - 1)
                St(Ikab) = St(Ikab - 1)
            Else
                Sa = En(Ikab - 1) - En(Ikab)
                If Sa <> 0 Then
                    '***************************************< INDの値で分岐
                    Select Case ind
                        '***************************************< 天底未定
                        Case -1
                            If Sa < 0 Then
                                If Max < En(Ikab) Then
                                    If En(Ikab) >= Pup * Min Then
                                        Call DECBOT(ind, Ikab, En(Ikab), Ntnt, Imin, Imax, Min, Max)
                                    Else
                                        Call CHNTOP(ind, Ikab, En(Ikab), Imax, Max)
                                    End If
                                End If
                            ElseIf Sa > 0 Then
                                If Min > En(Ikab) Then
                                    If En(Ikab) <= Pdn * Max Then
                                        Call DECTOP(ind, Ikab, En(Ikab), Ntnt, Imin, Imax, Min, Max)
                                    Else
                                        Call CHNBOT(ind, Ikab, En(Ikab), Imin, Min)
                                    End If
                                End If
                            End If
                            '***************************************< 天井探し
                        Case 0
                            If Sa < 0 Then
                                If Max < En(Ikab) Then
                                    Call CHNTOP(ind, Ikab, En(Ikab), Imax, Max)
                                End If
                            ElseIf Sa > 0 Then
                                If Max >= Pup * En(Ikab) Then
                                    Call DECTOP(ind, Ikab, En(Ikab), Ntnt, Imin, Imax, Min, Max)
                                ElseIf Min > En(Ikab) Then
                                    Call CHNBOT(ind, Ikab, En(Ikab), Imin, Min)
                                End If
                            End If
                            '***************************************< 底探し
                        Case 1
                            If Sa > 0 Then
                                If Min > En(Ikab) Then
                                    Call CHNBOT(ind, Ikab, En(Ikab), Imin, Min)
                                End If
                            ElseIf Sa < 0 Then
                                If Min <= Pdn * En(Ikab) Then
                                    Call DECBOT(ind, Ikab, En(Ikab), Ntnt, Imin, Imax, Min, Max)
                                ElseIf Max < En(Ikab) Then
                                    Call CHNTOP(ind, Ikab, En(Ikab), Imax, Max)
                                End If
                            End If
                    End Select
                End If
            End If
        Next
        '最初の天底が天井か底かを決める。Ind0=0:底、Ind0=1:天井
        If Ntnt > 0 Then
            If En(Imnx(1)) < En(Jmnx(1)) Then ind0 = 0 Else ind0 = 1
        End If
    End Sub
    Public Sub DECBOT(ByRef ind, ByRef IKAB, ByVal t, ByRef Ntnt, ByRef Imin, ByRef Imax, ByRef Min, ByRef Max) 'Pknd=3:Parabolic
        '***************************************< 底確定
        Ntnt = Ntnt + 1
        Minx(Ntnt) = Min
        Imnx(Ntnt) = Imin
        Jmnx(Ntnt) = IKAB
        ind = 0
        Min = t
        Imin = IKAB
        Call CHNTOP(ind, IKAB, t, Imax, Max)
    End Sub
    Public Sub CHNTOP(ByRef ind, ByRef Ikab, ByRef t, ByRef Imax, ByRef Max) 'Pknd=3:Parabolic, Pknd=22:Spwave
        '++++++++++++++++++++++++++++++++++< 天井候補変更
        Max = t
        Imax = Ikab
    End Sub
    Public Sub DECTOP(ByRef ind, ByRef Ikab, ByRef t, ByRef Ntnt, ByRef Imin, ByRef Imax, ByRef Min, ByRef Max)
        'Pknd=3:Parabolic, Pknd=22:Spwave
        '***************************************< 天井確定
        Ntnt = Ntnt + 1
        Minx(Ntnt) = Max
        Imnx(Ntnt) = Imax
        Jmnx(Ntnt) = Ikab
        ind = 1
        Max = t
        Imax = Ikab
        Call CHNBOT(ind, Ikab, t, Imin, Min)
    End Sub
    Public Sub CHNBOT(ByRef ind, ByRef Ikab, ByRef t, ByRef Imin, ByRef Min)
        'Pknd=3:Parabolic, Pknd=22:Spwave
        '++++++++++++++++++++++++++++++++++< 底候補変更
        tt = ind
        Min = t
        Imin = Ikab
    End Sub
    Public Sub CALSPR() 'Pknd=3:Parabolic, Pknd=22:Spwave
        '-++++++++++++++++++++++++++++
        ' ＳＰ変化率の計算
        '+++++++++++++++++++++++++++++
        ' EN()   :終値           (in)
        ' NTNT   :天底数         (in)
        ' MINX() :天底値         (in)
        ' IMNX() :天底立会日番号 (in)
        ' SP()   :ＳＰ変化率     (out)
        '-----------------------------
        Dim I0, I9 As Integer
        If Ntnt = 0 Then Exit Sub
        For i = 1 To Imnx(1) : SP(i) = -9999 : Next
        For Tnt = 1 To Ntnt
            I0 = Imnx(Tnt) + 1 : I9 = Imnx(Tnt + 1)
            If Tnt = Ntnt Then I9 = Nkab
            For i = I0 To I9 : SP(i) = FNSPR(En(i), Minx(Tnt)) : Next
            't = Dt(Imnx(Tnt))
            ind = (ind + 1) Mod 2
        Next
    End Sub
    Private Sub CALPRB() 'Pknd=3:Parabolic
        '---------------------------------------
        ' パラボリックの計算
        '---------------------------------------
        ' ＳＰ波動率10％で最初の天底を求めておく
        '---------------------------------------
        ' IMNX(1) : 最初のＳＰ天底データ番号 (in)
        ' IND0    : 上昇・下降傾向の別      (in)
        ' 0:上昇，1:下降
        ' NKAB    : データ数                (in)
        ' HI()    : 高値                    (in)
        ' LO()    : 安値                    (in)
        ' SAR()   : stop and revers point  (out)
        ' EP()    : extreme point          (out)
        ' AF()    : accelation factor      (out)
        '---------------------------------------
        'AfAdd = 0.02 '..< AFの加算値
        Min = 10 ^ 9 : Max = -Min
        For i = 1 To Imnx(1)
            If Min > Lo(i) Then Min = Lo(i)
            If Max < Hi(i) Then Max = Hi(i)
            Sar(i) = -9999 : Ep(i) = -9999 : Af(i) = -9999
        Next
        i = Imnx(1) : Sar(i) = Max : Ep(i) = Min : Af(i) = AfAdd
        t0 = Ep(i) - Sar(i) : t1 = t0 * Af(i)
        ind = ind0 : indBB = -1
        '
        For i = Imnx(1) + 1 To Nkab
            If Hi(i) = Hi(i - 1) And Lo(i) = Lo(i - 1) Then
                Sar(i) = Sar(i - 1) : Ep(i) = Ep(i - 1) : Af(i) = Af(i - 1)
                t0 = Ep(i) - Sar(i) : t1 = t0 * Af(i)
            ElseIf ind = 0 Then
                ' 上げ相場の計算
                Sar(i) = Sar(i - 1) + t1
                If Lo(i) < Sar(i) Then
                    '+++ ドテン売り
                    If indBB = 0 Then
                        Sec(i) = 1
                    End If
                    ind = 1 : Min = Lo(i) : indBB = 1
                    Sar(i) = Max : Ep(i) = Min : Af(i) = AfAdd
                    t0 = Ep(i) - Sar(i) : t1 = t0 * Af(i)
                Else
                    '+++ 上げ相場続く
                    If Max >= Hi(i) Then
                        If Min > Lo(i) Then
                            Min = Lo(i)
                        End If
                        Ep(i) = Ep(i - 1) : Af(i) = Af(i - 1)
                        t0 = Ep(i) - Sar(i) : t1 = t0 * Af(i)
                    Else
                        Max = Hi(i)
                        If Min > Lo(i) Then
                            Min = Lo(i)
                        End If
                        Sar(i) = Sar(i - 1) + t1 : Ep(i) = Max
                        If Af(i - 1) < 0.2 Then
                            Af(i) = Af(i - 1) + AfAdd
                        Else
                            Af(i) = 0.2
                        End If
                        t0 = Ep(i) - Sar(i) : t1 = t0 * Af(i)
                    End If
                End If
            Else
                '< 下げ相場の計算
                Sar(i) = Sar(i - 1) + t1
                If Hi(i) > Sar(i) Then
                    '+++ ドテン買い
                    If indBB = 1 Then
                        Sec(i) = 1
                    End If
                    ind = 0 : Max = Hi(i) : indBB = 0
                    Sar(i) = Min : Ep(i) = Max : Af(i) = AfAdd
                    t0 = Ep(i) - Sar(i) : t1 = t0 * Af(i)
                Else
                    '+++ 下げ相場続く
                    If Min <= Lo(i) Then
                        If Max < Hi(i) Then
                            Max = Hi(i)
                        End If
                        Ep(i) = Ep(i - 1) : Af(i) = Af(i - 1)
                    Else
                        Min = Lo(i)
                        If Max < Hi(i) Then
                            Max = Hi(i)
                        End If
                        Sar(i) = Sar(i - 1) + t1 : Ep(i) = Min
                        If Af(i - 1) < 0.2 Then
                            Af(i) = Af(i - 1) + AfAdd
                        Else
                            Af(i) = 0.2
                        End If
                    End If
                    t0 = Ep(i) - Sar(i) : t1 = t0 * Af(i)
                End If
            End If
        Next
    End Sub

    Public Function FNSPR(ByVal A As Single, ByVal B As Single) As Single 'Pknd=3:Parabolic
        '++++++++++++++++++++++++
        ' ＳＰ変化率（％）の計算
        '++++++++++++++++++++++++
        FNSPR = 200 * (A - B) / (A + B)
    End Function

    Private Sub CLKAGI() 'Pknd=4:Kagiasi
        '------------------
        ' カギ足の計算
        '------------------
        For i = 0 To 2000 : Low(i) = 0 : Upp(i) = 0 : Tno(i) = 0 : Next

        i = 1
        Do Until En(i) > 10
            i = i + 1
        Loop
        '< １本目の足
        i0 = i : n = 1
        For i = i0 + 1 To Nkab
            K = En(i) - En(i0)
            If K <> 0 Then
                If K < 0 Then
                    '< 下げた
                    t = En(i0) - Haba
                    If Af0 = 1 Then t = (1 - Haba / 100) * En(i0)
                    If t >= En(i) Then Low(1) = En(i) : Upp(1) = En(i0) : ind0 = 1 : jnd(1) = 1 : Tno(1) = i : Exit For
                Else
                    '< 上げた
                    t = En(i0) + Haba
                    If Af0 = 1 Then t = (1 + Haba / 100) * Low(1)
                    If t <= En(i) Then Low(1) = En(i0) : Upp(1) = En(i) : ind0 = 0 : jnd(1) = 0 : Tno(1) = i : Exit For
                End If
            End If
        Next
        ii = Low(1) : jj = Upp(1)
        '< ２本目以後の足
        ind = ind0
        i0 = i
        For i = i0 + 1 To Nkab
            K = En(i) - En(i - 1)
            If K <> 0 Then
                If ind = 1 Then '< 下げ途中
                    If K < 0 Then '< 下げた
                        If Low(n) > En(i) Then '< さらに下げた
                            Low(n) = En(i)
                        End If
                    Else          '< 上げた
                        If Af0 = 0 Then
                            t = Low(n) + Haba
                        Else
                            t = (1 + Haba / 100) * Low(n)
                        End If
                        If t <= En(i) Then '< 上げに転換
                            n = n + 1 : Tno(n) = i
                            Low(n) = Low(n - 1) : Upp(n) = En(i)
                            ind = 0 : jnd(n) = 0 : Tno(n) = i
                        End If
                    End If
                Else            '< 上げ途中
                    If K > 0 Then '< 上げた
                        If Upp(n) < En(i) Then '< さらに上げた
                            Upp(n) = En(i)
                        End If
                    Else          '< 下げた
                        If Af0 = 0 Then
                            t = Upp(n) - Haba
                        Else
                            t = (1 - Haba / 100) * Upp(n)
                        End If
                        If t >= En(i) Then '< 下げに転換
                            n = n + 1 : Tno(n) = i
                            Upp(n) = Upp(n - 1) : Low(n) = En(i)
                            ind = 1 : jnd(n) = 1 : Tno(n) = i
                        End If
                    End If
                End If
            End If
        Next
        Nkgi = n 'カギ足の行数
    End Sub
    Private Sub CLSHIN()
        'Pknd=5:Shinne
        '***********************************************
        '      新値足の計算       
        '***********************************************
        ' 新値Nuki本数の検査
        ' n : '当該柱数
        ' m : '遡って新値を検査する柱数
        ' ind : 0=新値抜き達成, 1=新値抜きしていない
        '***********************************************
        Dim Dif As Integer '終値の前日差

        i = 1
        Do Until En(i) > 10 '出だし株価が10円以下は勘定外
            i = i + 1
        Loop
        i0 = i '観察開始データ番号
        '+++++++++++++++++ 観察開始時の上げ下げ判定
        n = 0 '柱番号
        For i = i0 + 1 To Nkab
            Dif = En(i) - En(i - 1) '前日差
            If Dif <> 0 Then
                If Dif > 0 Then
                    jnd(1) = 0
                    Low(1) = En(i - 1) : Upp(1) = En(i) : Tno(1) = i
                Else
                    jnd(1) = 1
                    Low(1) = En(i) : Upp(1) = En(i - 1) : Tno(1) = i
                End If
            End If
            ii = Low(1) : jj = Upp(1) : k = Tno(1)
            nn = jnd(1)
            Exit For
        Next
        n = 1 '柱番号
        i0 = i '新値判定開始日のデータ番号

        '++++++++++++++++++ 柱数が新値抜き本数以下のとき
        For i = i0 + 1 To Nkab
            If n < Nuki Then
                If En(i) < Low(n) Then
                    n = n + 1 : jnd(n) = 1 : nn = jnd(n)
                    Low(n) = En(i) : Upp(n) = Upp(n - 1) : Tno(n) = i
                    ii = Low(n) : jj = Upp(n) : k = Tno(n)
                    ii = ii
                End If
                If En(i) > Upp(n) Then
                    n = n + 1 : jnd(n) = 0 : nn = jnd(n)
                    Low(n) = Upp(n - 1) : Upp(n) = En(i) : Tno(n) = i
                    ii = Low(n) : jj = Upp(n) : k = Tno(n)
                    ii = ii
                End If
            Else
                If En(i) < Low(n) Then
                    ind = 0
                    For j = n - Nuki + 1 To n
                        If En(i) >= Low(j) Then ind = 1 : Exit For
                    Next
                    If ind = 0 Then
                        n = n + 1 : jnd(n) = 1 : nn = jnd(n)
                        Low(n) = En(i) : Upp(n) = Low(n - 1) : Tno(n) = i
                        ii = Low(n) : jj = Upp(n) : k = Tno(n)
                        ii = ii
                    End If
                ElseIf En(i) > Upp(n) Then
                    ind = 0
                    For j = n - Nuki + 1 To n
                        If En(i) <= Upp(j) Then ind = 1 : Exit For
                    Next
                    If ind = 0 Then
                        n = n + 1 : jnd(n) = 0 : nn = jnd(n)
                        Low(n) = Upp(n - 1) : Upp(n) = En(i) : Tno(n) = i
                        ii = Low(n) : jj = Upp(n) : k = Tno(n)
                        ii = ii
                    End If
                End If
            End If
        Next i

        Nsin = n '新値合計本数
    End Sub

    Private Sub CalRenkou() 'Pknd=6:Renkou
        '-------------------
        '練行足の計算
        '-------------------
        Dim En0, En1, Dif As Integer
        i = 1
        Do While En(i) <= 10
            i = i + 1
        Loop
        i0 = i : Max = 0
        For i = i0 To Nkab
            If Max < En(i) Then Max = En(i)
        Next
        n = 0 '< 足の本数
        En0 = En(i0) : En1 = En(i0)

        Call DCHABA() 'En(i0)でポイントの値幅Habaを決める

        For i = i0 + 1 To Nkab
            Dif = En(i) - En(i - 1)
            If Dif <> 0 Then
                If Dif < 0 Then
                    dlt = En0 - En(i)
                    Do While dlt >= Haba '下げた
                        n = n + 1 : Tno(n) = i : jnd(n) = 1
                        En1 = En0 : En0 = En0 - Haba
                        Upp(n) = En1 : Low(n) = En0
                        dlt = En0 - En(i)
                    Loop
                Else
                    dlt = En(i) - En1
                    Do While dlt >= Haba '上げた
                        n = n + 1 : Tno(n) = i : jnd(n) = 0
                        En0 = En1 : En1 = En1 + Haba
                        Upp(n) = En1 : Low(n) = En0
                        dlt = En(i) - En1
                    Loop
                End If
            End If
        Next
        Nren = n '足の本数
    End Sub

    Private Sub DCHABA() 'Pknd=6:Renkou, Pknd=7:PntFig
        '+++++++++++++++++++++++++++++++++++++++++++++++++
        ' 終値初期値En(1)から１ポイントの値幅Habaを決める
        '+++++++++++++++++++++++++++++++++++++++++++++++++
        ii = Max
        If Max >= 1000000 Then Haba = 10000
        If Max < 500000 Then Haba = 2000
        If Max < 100000 Then Haba = 1000
        If Max < 50000 Then Haba = 200
        If Max < 10000 Then Haba = 100
        If Max < 5000 Then Haba = 20
        If Max < 1000 Then Haba = 10
        If Max < 200 Then Haba = 5
    End Sub

    Private Sub CLPNFG() 'Pknd=7:PntFig
        '++++++++++++++++++++++++++++++++++++  
        ' ポイント・アンド・フィギュアの計算 
        '++++++++++++++++++++++++++++++++++++  
        Dim En0 As Integer '柱最初の終値
        Dim Dif As Integer '直前の柱の終値と当日の終値との差
        Dim Lim As Integer '柱が動く最小差

        For i = 0 To 2000 : Low(i) = 0 : Upp(i) = 0 : Tno(i) = 0 : jnd(i) = 0 : Next

        i = 1
        Do Until En(i) > 10 '出だし株価が10円以下は勘定外
            i = i + 1
        Loop
        'i0 = i      '観察開始データ番号
        i0 = i : Max = 0
        For i = i0 To Nkab
            If Max < En(i) Then Max = En(i)
        Next

        ii = Max

        Call DCHABA() 'En(i0)でポイントの値幅Habaを決める

        Lim = Npnt * Haba '柱が動く最小差＝柱の動きにはこの値以上の差が必要

        Dno(1) = i0 '最初の柱の開始データ番号
        Tno(1) = i0

        '+++++++++++++++++ 出だしの上げ下げ方向を決める
        m0 = 1 '最初の柱番号
        ii = En(i0) '終値の初期値
        ii = Haba 'DCHABA()で決めてある
        For i = i0 + 1 To Nkab
            ii = En(i)
            Dif = En(i) - En(i0) '最初からの値動き幅
            If Dif > 0 Then '初期値から上げた
                En0 = (En(i0) \ Haba) * Haba                  '上げなので丸めのため終値初期値をHabaに対して切り下げた
                Dif = En(i) - En0                             '終値初期値から上げた額
                If Dif >= (Npnt + 1) * Haba Then '丸めた観察開始時終値からNpnt以上上げた
                    Tno(m0) = 1
                    Low(m0) = En0                                '切り下げた終値初期値を最初の柱の最安値にした
                    n = Dif \ Haba                               '最初にｎ個の上げ記号を描く
                    For ii = 1 To n : jnd(ii) = 0 : Next         '各記号を上げの印にする
                    En0 = (En(i) \ Haba) * Haba                  '上げ相場に入ったので切り下げた終値を検討値とした
                    Upp(m0) = En0                                '現在の検討値を柱の仮の最高値にした
                    Exit For                                     '出だしの上げが決まったのでfor loopから出る
                End If
            Else            '
                En0 = ((En(i0) - Haba + 1) \ Haba + 1) * Haba '下げなので丸めのため終値初期値をHabaに対して切り上げた
                Dif = En0 - En(i)                             '終値初期値から下げた額
                If Dif >= (Npnt + 1) * Haba Then '丸めた観察開始時終値からNpnt以上下げた
                    Tno(m0) = 1
                    Upp(m0) = En0                                '切り上げた終値初期値を最初の柱の最高値にした
                    n = Dif \ Haba                               '最初にｎ個の下げ記号を描く
                    For ii = 1 To n : jnd(ii) = 0 : Next         '各記号を下げの印にする
                    En0 = ((En(i) + Haba - 1) \ Haba + 1) * Haba '下げ相場に入ったので切り上げた終値を検討値とした
                    Low(m0) = En0                                '現在の検討値を柱の仮の最安値にした
                    Exit For                                     '出だしの下げが決まったのでfor loopから出る
                End If
            End If
        Next
        n0 = n '出だしの記号数
        i0 = i '出だしが決まったときのデータ番号

        '+++++++++++++++++出だし以後の上げ下げ方向を決める
        For i = i0 + 1 To Nkab
            If jnd(n0) = 0 Then '直前の柱は上げ
                Dif = En(i) - En0 '現在の柱終値との差
                If Dif >= Haba Then                    '株価が１ポイント以上がった
                    n = Dif \ Haba                                 '新たに追加する上げの記号数
                    For ii = n0 + 1 To n0 + n : jnd(ii) = 0 : Next '上げ記号をn個追加した
                    n0 = n0 + n                                    '現在の柱までの記号数の合計
                    En0 = En0 + n * Haba                           '上げ柱の最高値を更新する
                    Upp(m0) = En0                                  '上げ柱の現在の最高値
                    ii = Upp(m0)
                    ii = ii
                ElseIf -Dif >= (Npnt + 1) * Haba Then '下げに転じた
                    n = (-Dif) \ Haba - 1                          '下げに転じたときの下げ記号数
                    For ii = n0 + 1 To n0 + n : jnd(ii) = 1 : Next '下げ記号をｎ個新たに追加した
                    m0 = m0 + 1                                    '柱の数を１増やす
                    Dno(m0) = i                                    'm0番目の柱の開始データ番号
                    Tno(m0) = n0 + 1                               'm0番目の柱の開始記号番号
                    n0 = n0 + n                                    '現在の柱までの記号数の合計
                    Upp(m0) = Upp(m0 - 1) - Haba                   '下げに転じたときの柱の最高値
                    'ii = Upp(m0)
                    En0 = Upp(m0) - n * Haba                       '新たな下げ柱の下値
                    Low(m0) = En0                                  '下げ柱の現在の最安値
                    ii = ii
                End If
            Else '直前の柱は下げ
                Dif = En(i) - En0 '現在の柱終値との差
                If -Dif >= Haba Then '株価が１ポイント以上下がった
                    n = (-Dif) \ Haba '新たに追加する下げの記号数
                    For ii = n0 + 1 To n0 + n : jnd(ii) = 1 : Next '下げ記号をn個追加した
                    n0 = n0 + n                                    '現在の柱までの記号数の合計
                    En0 = En0 - n * Haba                           '下げ柱の最安値を更新する
                    Low(m0) = En0                                  '下げ柱の現在の最安値
                    ii = En0
                ElseIf Dif >= (Npnt + 1) * Haba Then '上げに転じた
                    n = Dif \ Haba - 1                             '新たに追加する下げの記号数
                    For ii = n0 + 1 To n0 + n : jnd(ii) = 0 : Next '上げ記号をn個新たに追加した
                    m0 = m0 + 1                                    '柱の数を１増やす
                    Dno(m0) = i                                    'm0番目の柱の開始データ番号
                    Tno(m0) = n0 + 1                             'm0番目の柱の開始記号番号
                    n0 = n0 + n                                    '現在の柱までの記号数の合計
                    Low(m0) = Low(m0 - 1) + Haba                       '上げに転じたときの柱の最安値
                    En0 = Low(m0) + n * Haba                       '新たな柱の高値
                    Upp(m0) = En0                                  '上げ柱の現在の最高値
                    ii = ii
                End If
            End If
        Next
        Nmrk = n0 '上げ下げ記号数の合計
        Ngyo = m0 '柱数の合計
    End Sub

    Private Sub CalItchim() 'Pknd=8:Ichimoku
        '+++++++++++++++++++++ 一目均衡表の計算
        i = 1
        Do While En(i) = -9999
            i = i + 1
        Loop
        i0 = i
        '***** 転換線の計算 *****
        For i = 1 To i0 + 7 : Tnk(i) = -9999 : Next
        For i = i0 + 8 To Nkab
            Min = 10 ^ 9 : Max = -Min
            For j = i - 8 To i
                If En(j) <> -9999 Then
                    If Min > Lo(j) Then Min = Lo(j)
                    If Max < Hi(j) Then Max = Hi(j)
                End If
            Next
            Tnk(i) = (Min + Max) / 2
        Next
        '***** 基準線の計算 *****
        For i = 1 To i0 + 24 : Kjn(i) = -9999 : Next
        For i = i0 + 25 To Nkab
            Min = 10 ^ 9 : Max = -Min
            For j = i - 25 To i
                If En(j) <> -9999 Then
                    If Min > Lo(j) Then Min = Lo(j)
                    If Max < Hi(j) Then Max = Hi(j)
                End If
            Next
            Kjn(i) = (Min + Max) / 2
        Next
        '***** 先行スパン１の計算 *****
        For i = 1 To i0 + 74 : SP1(i) = -9999 : Next
        For i = i0 + 50 To Nkab - 25
            SP1(i + 25) = (Tnk(i) + Kjn(i)) / 2
            ii = SP1(i + 25)
        Next
        '***** 先行スパン２の計算 *****
        For i = 1 To i0 + 75 : SP2(i) = -9999 : Next
        For i = i0 + 51 To Nkab - 25
            Min = 10 ^ 9 : Max = -Min
            For j = i - 51 To i
                If En(j) <> -9999 Then
                    If Min > Lo(j) Then Min = Lo(j)
                    If Max < Hi(j) Then Max = Hi(j)
                End If
            Next
            SP2(i + 25) = (Min + Max) / 2
        Next
        '***** 遅行スパンの計算 *****
        For i = i0 + 25 To Nkab
            TPN(i - 25) = En(i)
        Next
        For i = Nkab - 25 To Nkab : TPN(i) = -9999 : Next

    End Sub

    Private Sub ClPsyc() 'Pknd=9:Psycolog
        '++++++++++++++++++++++++++++++++
        'サイコロジカル・ラインの計算
        '++++++++++++++++++++++++++++++++
        For i = 1 To 12 : Psy(i) = -9999 : Next
        Tot = 0
        For i = 2 To 13
            If En(i) > En(i - 1) Then Tot = Tot + 1
        Next
        Psy(13) = 100 * Tot / 12
        For i = 14 To Nkab
            If En(i - 12) > En(i - 13) Then Tot = Tot - 1
            If En(i) > En(i - 1) Then Tot = Tot + 1
            Psy(i) = 100 * Tot / 12
        Next
    End Sub

    Private Sub CalMomentum() 'Pknd=10:Momentum
        '+++++++++++++++++++++++++++++++++++++++
        ' モメンタムの計算   
        '+++++++++++++++++++++++++++++++++++++++
        For i = 1 To Dtmp : Mom(Ikab) = -9999 : Next
        For Ikab = Dtmp + 1 To Nkab
            If En(Ikab) = -9999 Or En(Ikab - Dtmp) = -9999 Then
                Mom(Ikab) = -9999
            Else
                Mom(Ikab) = En(Ikab) - En(Ikab - Dtmp)
            End If
        Next
    End Sub

    Private Sub CalROC() 'Pknd=11:RateOfChange
        '+++++++++++++++++++++++++++++++++++++++
        ' Rate of Changeの計算   
        '+++++++++++++++++++++++++++++++++++++++
        For i = 1 To Dmov : ROC(Ikab) = -9999 : Next
        For Ikab = Dmov + 1 To Nkab
            If En(Ikab) = -9999 Or En(Ikab - Dmov) = -9999 Then
                ROC(Ikab) = -9999
            Else
                ROC(Ikab) = 100 * (En(Ikab) - En(Ikab - Dmov)) / En(Ikab - Dmov)
            End If
        Next
    End Sub

    Private Sub CALPCR() 'Pknd=12:PcROscil
        '-------------------------
        ' ％Ｒオシレーターの計算
        '-------------------------
        For i = 1 To Dmov - 1
            Pcr(i) = -9999
        Next
        For i = Dmov To Nkab
            Min = 10 ^ 9 : Max = -Min
            For j = i - Dmov + 1 To i
                If Min > Lo(j) Then Min = Lo(j)
                If Max < Hi(j) Then Max = Hi(j)
            Next
            If Min = Max Then
                Pcr(i) = Pcr(i - 1)
            Else
                Pcr(i) = 100 * (En(i) - Max) / (Max - Min)
            End If
        Next
    End Sub

    Private Sub CALRSI() 'Pknd=13:RelStrInd, Pknd=20:VolumeRatio
        '++++++++++++++++++++++++++++++
        'Relative Strength Indexの計算
        '++++++++++++++++++++++++++++++
        Dim Dif As Integer
        Dim Tupp, Tdwn As Single
        Dim Upp(4000), Dwn(4000) As Single

        For i = 2 To Nkab
            Dif = En(i) - En(i - 1)
            If Dif > 0 Then Upp(i) = Dif Else Dwn(i) = -Dif
        Next
        Tupp = 0 : Tdwn = 0
        For i = 2 To Dmov + 1
            Tupp = Tupp + Upp(i) / Dmov
            Tdwn = Tdwn + Dwn(i) / Dmov
        Next
        RSI(Dmov + 1) = 100 * Tupp / (Tupp + Tdwn)
        For i = Dmov + 2 To Nkab
            Tupp = ((Dmov - 1) * Tupp + Upp(i)) / Dmov
            Tdwn = ((Dmov - 1) * Tdwn + Dwn(i)) / Dmov
            RSI(i) = 100 * Tupp / (Tupp + Tdwn)
        Next
        For i = 1 To Dmov : RSI(i) = -9999 : Next
    End Sub

    Private Sub CalStoch() 'Pknd=14:Stochastics
        '++++++++++++++++++++++++++++++
        ' Stochasticsの計算
        '------------------------------
        ' PCK() : %K 
        ' PCD() : %D 
        ' SD()  : %Dの３日移動平均
        '++++++++++++++++++++++++++++++
        Dim Tmin(4000), Tmax(4000) As Single
        'Tmin(i)=ｎ日間の最安値，Tmax(i)=ｎ日間の最高値
        Min = 10 ^ 9 : Max = -Min
        For i = 1 To Dmov - 1
            If Min > Lo(i) Then Min = Lo(i)
            If Max < Hi(i) Then Max = Hi(i)
        Next
        For i = Dmov To Nkab
            If Min > Lo(i) Then Min = Lo(i)
            If Max < Hi(i) Then Max = Hi(i)
            Tmin(i) = Min : Tmax(i) = Max
        Next
        '************
        For i = Dmov To Nkab
            PCK(i) = 100 * (En(i) - Tmin(i)) / (Tmax(i) - Tmin(i))
            If i <= Nkab - 2 Then
                t0 = 0 : t1 = 0
                For j = i To i + 2
                    t0 = t0 + En(j) - Tmin(j)
                    t1 = t1 + Tmax(j) - Tmin(j)
                Next
                PCD(i + 2) = 100 * t0 / t1
            End If
        Next
        For i = Dmov + 2 To Nkab
            SD(i) = (PCD(i - 2) + PCD(i - 1) + PCD(i)) / 3
        Next
        For i = 1 To Dmov - 1 : PCK(i) = -9999 : Next
        For i = 1 To Dmov + 1 : PCD(i) = -9999 : SD(i) = -9999 : Next
    End Sub
    Private Sub CLMACD() 'Pkdn=16:MavCnvDvf
        '++++++++++++++++++++++++++++
        '　ＭＡＣＤの計算　
        '++++++++++++++++++++++++++++
        Dim tot, Coef As Single

        '最初に必要な短期・中期単純移動平均の計算
        tot = 0
        For i = 1 To Dmv1 : tot = tot + En(i) : Next
        Mav1(Dmv1) = tot / Dmv1
        ii = Mav1(Dmv1) : jj = En(Dmv1)
        For i = Dmv1 + 1 To Dmv2 : tot = tot + En(i) : Next
        Mav2(Dmv2) = tot / Dmv2
        For i = 1 To Dmv1 - 1 : Mav1(i) = -9999 : Next
        For i = 1 To Dmv2 - 1 : Mav2(i) = -9999 : Next
        '短期指数平滑平均の計算
        Coef = 2 / (Dmv1 + 1)
        For i = Dmv1 + 1 To Nkab
            Mav1(i) = Mav1(i - 1) + Coef * (En(i) - Mav1(i - 1))
        Next
        '中期指数平滑平均の計算
        Coef = 2 / (Dmv2 + 1)
        For i = Dmv2 + 1 To Nkab
            Mav2(i) = Mav2(i - 1) + Coef * (En(i) - Mav2(i - 1))
        Next
        'ＭＡＣＤの計算
        For i = 1 To Dmv2 - 1 : MACD(i) = -9999 : Next
        For i = Dmv2 To Nkab
            MACD(i) = Mav1(i) - Mav2(i)
        Next
        'シグナル単純移動平均の計算
        For i = 1 To Dmv2 + Dsig - 1 : Sig(i) = -9999 : Next
        tot = 0
        For i = Dmv2 + 1 To Dmv2 + Dsig - 1
            tot = tot + MACD(i)
        Next
        For i = Dmv2 + Dsig To Nkab
            tot = tot + MACD(i) : Sig(i) = tot / Dsig

            tot = tot - MACD(i - Dsig)
        Next
    End Sub

    Private Sub CalShinohara() 'Pknd=17:ShinoharaRatio
        Dim Kyo(4000), Jak(4000) As Single
        Dim Tkyo, Tjak, Naka As Single
        '--------------------
        ' 篠原レシオの計算
        '--------------------
        '***** ARの計算 *****
        For i = 1 To Nkab
            Kyo(i) = Hi(i) - St(i) : Jak(i) = St(i) - Lo(i)
        Next
        For i = 1 To 25 : AR(i) = -9999 : Next
        Tkyo = 0 : Tjak = 0
        For i = 1 To 26
            Tkyo = Tkyo + Kyo(i) : Tjak = Tjak + Jak(i)
        Next
        AR(26) = 100 * Tkyo / Tjak
        For i = 27 To Nkab
            Tkyo = Tkyo - Kyo(i - 26) + Kyo(i)
            Tjak = Tjak - Jak(i - 26) + Jak(i)
            AR(i) = 100 * Tkyo / Tjak
        Next
        '***** BRの計算 *****
        For i = 2 To Nkab
            Kyo(i) = Hi(i) - En(i - 1) : Jak(i) = En(i - 1) - Lo(i)
        Next
        For i = 1 To 26 : BR(i) = -9999 : Next
        Tkyo = 0 : Tjak = 0
        For i = 2 To 27
            Tkyo = Tkyo + Kyo(i) : Tjak = Tjak + Jak(i)
        Next
        BR(27) = 100 * Tkyo / Tjak
        For i = 28 To Nkab
            Tkyo = Tkyo - Kyo(i - 26) + Kyo(i)
            Tjak = Tjak - Jak(i - 26) + Jak(i)
            BR(i) = 100 * Tkyo / Tjak
        Next
        '***** CRの計算 *****
        For i = 2 To Nkab
            Naka = (Hi(i - 1) + Lo(i - 1)) / 2
            Kyo(i) = Hi(i) - Naka : Jak(i) = Naka - Lo(i)
        Next
        For i = 1 To 26 : CR(i) = -9999 : Next
        Tkyo = 0 : Tjak = 0
        For i = 2 To 27
            Tkyo = Tkyo + Kyo(i) : Tjak = Tjak + Jak(i)
        Next
        CR(27) = 100 * Tkyo / Tjak
        For i = 28 To Nkab
            Tkyo = Tkyo - Kyo(i - 26) + Kyo(i)
            Tjak = Tjak - Jak(i - 26) + Jak(i)
            CR(i) = 100 * Tkyo / Tjak
        Next
        '*****主ベルト１の計算 *****
        For i = 1 To 40 + 17 : Shu1(i) = -9999 : Next
        Tkyo = 0 : Tjak = 0
        For i = 2 To 41
            Tkyo = Tkyo + Kyo(i) : Tjak = Tjak + Jak(i)
        Next
        Shu1(41 + 17) = 100 * Tkyo / Tjak
        For i = 42 To Nkab - 17
            Tkyo = Tkyo - Kyo(i - 40) + Kyo(i)
            Tjak = Tjak - Jak(i - 40) + Jak(i)
            Shu1(i + 17) = 100 * Tkyo / Tjak
        Next
        '*****主ベルト２の計算 *****
        For i = 1 To 52 + 26 : Shu1(i) = -9999 : Next
        Tkyo = 0 : Tjak = 0
        For i = 2 To 53
            Tkyo = Tkyo + Kyo(i) : Tjak = Tjak + Jak(i)
        Next
        Shu2(53 + 26) = 100 * Tkyo / Tjak
        For i = 53 To Nkab - 26
            Tkyo = Tkyo - Kyo(i - 52) + Kyo(i)
            Tjak = Tjak - Jak(i - 52) + Jak(i)
            Shu2(i + 26) = 100 * Tkyo / Tjak
        Next
        '*****副ベルト１の計算 *****
        For i = 1 To 10 + 5 : Fuk1(i) = -9999 : Next
        Tkyo = 0 : Tjak = 0
        For i = 2 To 11
            Tkyo = Tkyo + Kyo(i) : Tjak = Tjak + Jak(i)
        Next
        Fuk1(11 + 5) = 100 * Tkyo / Tjak
        For i = 11 To Nkab - 5
            Tkyo = Tkyo - Kyo(i - 10) + Kyo(i)
            Tjak = Tjak - Jak(i - 10) + Jak(i)
            Fuk1(i + 5) = 100 * Tkyo / Tjak
        Next
        '*****副ベルト２の計算 *****
        For i = 1 To 20 + 9 : Fuk2(i) = -9999 : Next
        Tkyo = 0 : Tjak = 0
        For i = 2 To 21
            Tkyo = Tkyo + Kyo(i) : Tjak = Tjak + Jak(i)
        Next
        Fuk2(21 + 9) = 100 * Tkyo / Tjak
        For i = 21 To Nkab - 9
            Tkyo = Tkyo - Kyo(i - 20) + Kyo(i)
            Tjak = Tjak - Jak(i - 20) + Jak(i)
            Fuk2(i + 9) = 100 * Tkyo / Tjak
        Next
    End Sub

    Private Sub CALDMI() 'Pknd=18:Directional Movement Index
        Dim A%, B%, C%, D%, P%, M%
        Dim TPLS!, TMNS!, TMP!, TTR!
        '*************************************
        '* Directional Movement Indexの計算  *
        '*************************************
        For i = 1 To Nkab
            If En(i) <> -9999 And En(i - 1) <> -9999 Then
                A = Hi(i - 1) : B = Lo(i - 1) : C = Hi(i) : D = Lo(i)
                P = C - A : M = B - D
                If (P < 0 And M < 0) Or P = M Then
                    Pdm(i) = 0 : Mdm(i) = 0
                Else
                    If P > M Then
                        Pdm(i) = P : Mdm(i) = 0
                    Else
                        Pdm(i) = 0 : Mdm(i) = M
                    End If
                End If
                TPLS = C - D : TMNS = C - En(i - 1)
                If TPLS > TMNS Then
                    TMP = TPLS
                Else
                    TMP = TMNS
                End If
                If TMP < En(i - 1) - D Then
                    Tr(i) = En(i - 1) - D
                Else
                    Tr(i) = TMP
                End If
            End If
        Next
        For i = 1 To i0 + Dmov - 1
            Pdi(i) = -9999 : Mdi(i) = -9999
        Next
        TPLS = 0 : TMNS = 0 : TTR = 0
        For i = i0 + 1 To i0 + Dmov
            TPLS = TPLS + Pdm(i) : TMNS = TMNS + Mdm(i) : TTR = TTR + Tr(i)
        Next
        Pdi(i0 + Dmov) = 100 * TPLS / TTR
        Mdi(i0 + Dmov) = 100 * TMNS / TTR
        For i = i0 + Dmov + 1 To Nkab
            TPLS = TPLS - Pdm(i - Dmov) + Pdm(i)
            TMNS = TMNS - Mdm(i - Dmov) + Mdm(i)
            TTR = TTR - Tr(i - Dmov) + Tr(i)
            Pdi(i) = 100 * TPLS / TTR : Mdi(i) = 100 * TMNS / TTR
        Next
        For i = 1 To Nkab
            If Pdi(i) = -9999 Or Mdi(i) = -9999 Then
                Tdx(i) = -9999
            Else
                Tdx(i) = 100 * Math.Abs(Pdi(i) - Mdi(i)) / Math.Abs(Pdi(i) + Mdi(i))
            End If
        Next
        i = 1
        Do While Tdx(i) = -9999
            Adx(i) = -9999 : i = i + 1
        Loop
        i0 = i
        TPLS = 0
        For i = i0 To i0 + Dmov - 1
            TPLS = TPLS + Tdx(i)
            If i < i0 + Dmov - 1 Then Adx(i) = -9999
        Next
        Adx(i0 + Dmov - 1) = TPLS / Dmov
        For i = i0 + Dmov To Nkab
            TPLS = TPLS - Tdx(i - Dmov) + Tdx(i)
            Adx(i) = TPLS / Dmov
        Next
        For i = 1 To i0 : Adxr(i) = -9999 : Next
        For i = i0 + 1 To Nkab
            If Adx(i - Dmov) = -9999 Or Adx(i) = -9999 Then
                Adxr(i) = -9999
            Else
                Adxr(i) = (Adx(i - Dmov) + Adx(i)) / 2
            End If
        Next
    End Sub

    Private Sub CALRCI() 'Pknd=19:RankCorrelationIndex
        Dim Coef, Tot As Single
        '--------------
        ' ＲＣＩの計算
        '--------------
        Coef = Dmov * Dmov - 1 : Coef = Dmov * Coef
        Coef = 6 / Coef

        For i = 1 To Dmov - 1 : Cor(i) = -9999 : Next
        For i = Dmov To Nkab
            For j = 1 To Dmov
                No(j) = j : BB(j) = En(i - Dmov + j)
            Next
            Call SRTDEC()
            For j = 1 To Dmov
                jj = j + 1 : n = 1
                Do While BB(j) = BB(jj)
                    jj = jj + 1 : n = n + 1
                Loop
                If n > 1 Then
                    Tot = 0
                    For k = j To jj - 1 : Tot = Tot + k : Next
                    For k = j To jj - 1 : AA(k) = Tot / n : Next
                    j = jj - 1
                Else
                    AA(j) = j
                End If
            Next
            Call SRTASC()
            For j = 1 To Dmov : BB(j) = Dmov + 1 - j : Next
            Cor(i) = 0
            For j = 1 To Dmov
                Cor(i) = Cor(i) + (AA(j) - BB(j)) * (AA(j) - BB(j))
            Next
            Cor(i) = 100 * (1 - Coef * Cor(i))
        Next
    End Sub

    Public Sub SRTASC() 'Pknd=19:RankCorrelationIndex
        Dim T, TT, T0, ISRT%, S%
        '---------------------------------
        ' 昇順にシェルソート
        '---------------------------------
        ' NDAT : データ数         (in)
        ' X()  : ソートするデータ (in,out)
        '---------------------------------
        T = Dmov
        Do While T > 0
            T = Int(T / 2)
            TT = Dmov - T
            For ISRT = 1 To TT
                S = ISRT
                Do
                    If No(S) <= No(S + T) Then Exit Do
                    T0 = No(S) : No(S) = No(S + T) : No(S + T) = T0
                    T0 = BB(S) : BB(S) = BB(S + T) : BB(S + T) = T0
                    T0 = AA(S) : AA(S) = AA(S + T) : AA(S + T) = T0
                    S = S - T
                Loop While S >= 1
            Next
        Loop
    End Sub

    Public Sub SRTDEC() 'Pknd=19:RankCorrelationIndex
        Dim T, TT, ISRT%, S%, T0
        '---------------------------------
        ' 降順にシェルソート
        '---------------------------------
        ' NDAT : データ数         (in)
        ' X()  : ソートするデータ (in,out)
        '---------------------------------
        T = Dmov
        Do While T > 0
            T = Int(T / 2)
            TT = Dmov - T
            For ISRT = 1 To TT
                S = ISRT
                Do
                    If BB(S) >= BB(S + T) Then Exit Do
                    T0 = BB(S) : BB(S) = BB(S + T) : BB(S + T) = T0
                    T0 = No(S) : No(S) = No(S + T) : No(S + T) = T0
                    S = S - T
                Loop While S >= 1
            Next
        Loop
    End Sub

    Private Sub CALVOL() 'Pknd=20:VolumeRatio
        Dim Tupp, Tdwn As Single
        '----------
        'ＶＲの計算
        '----------
        For i = 1 To Dmov : VR(i) = -9999 : Next
        Tupp = 0 : Tdwn = 0
        For i = 1 To Dmov
            If En(i) > En(i - 1) Then
                Tupp = Tupp + Dk(i) '分子の出来高合計
            ElseIf En(i) = En(i - 1) Then
                Tupp = Tupp + Dk(i) / 2
            End If
            Tdwn = Tdwn + Dk(i) '分母の出来高合計
        Next
        VR(i0 + Dmov) = 100 * Tupp / Tdwn
        For i = Dmov + 1 To Nkab
            If En(i - Dmov) > En(i - Dmov - 1) Then
                Tupp = Tupp - Dk(i - Dmov)
            ElseIf En(i - Dmov) = En(i - Dmov - 1) Then
                Tupp = Tupp - Dk(i - Dmov) / 2
            End If
            If En(i) > En(i - 1) Then
                Tupp = Tupp + Dk(i)
            ElseIf En(i) = En(i - 1) Then
                Tupp = Tupp + Dk(i) / 2
            End If
            Tdwn = Tdwn - Dk(i - Dmov) + Dk(i)
            VR(i) = 100 * Tupp / Tdwn
        Next
    End Sub

    Private Sub CALOBV() 'Pknd=21:OnBalanceVolume
        '----------------------
        'OnBalanceVolumeの計算
        '----------------------
        OBV(1) = Dk(1)
        For i = 2 To Nkab
            If En(i) <> En(i - 1) Then
                If En(i) > En(i - 1) Then
                    OBV(i) = OBV(i - 1) + Dk(i)
                Else
                    OBV(i) = OBV(i - 1) - Dk(i)
                End If
            Else
                OBV(i) = OBV(i - 1)
            End If
        Next
    End Sub

    Private Sub Button1_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Cod = Cod0(Napp)
        i = Year0
        Call GETDAY() ' パンのデータベースから日足を採取
        Kst = 1 : Ken = Nkab
        Select Case Pknd
            Case 1
                Dtmp = Dmov
                Call MOVMAV() '短期移動平均の計算
                DrwEnvelope.Show()
                DrwEnvelope.MyGraph()
            Case 2
                Dtmp = Dmov
                Call MOVMAV() '短期移動平均の計算
                Call CALSIG() ' 移動日数DMOVE日の終値標準偏差を計算
                DrwBollin.Show()
                DrwBollin.MyGraph()
            Case 3
                Call TNTSPR()
                Call CALSPR()
                Call CALPRB() ' パラボリックの計算
                DrwParabo.Show()
                DrwParabo.MyGraph()
            Case 4
                Call CLKAGI()
                Ren = Nkgi
                DrwKagiasi.Show()
                DrwKagiasi.MyGraph()
            Case 5
                Call CLSHIN()
                Ken = Nsin : Ndsp = 100
                Ren = 10 * ((Nsin - 1) \ 10 + 1) : If Ren < Ndsp Then Rst = 1 : Ren = Ndsp
                Rst = Ren - Ndsp + 1 : Kst = Rst
                DrwShinne.Show()
                DrwShinne.MyGraph()
            Case 6
                Call CalRenkou()
                Ken = Nren : Ndsp = 100
                Ren = 10 * ((Nren - 1) \ 10 + 1) : If Ren < Ndsp Then Rst = 1 : Ren = Ndsp
                Rst = Ren - Ndsp + 1 : Kst = Rst
                DrwRenkou.Show()
                DrwRenKou.MyGraph()
            Case 7
                Call CLPNFG() 'ポイント・アンド・フィギュアの計算
                Ken = Ngyo : Ndsp = 30
                Ren = 10 * ((Ngyo - 1) \ 10 + 1) : If Ren < Ndsp Then Rst = 1 : Ren = Ndsp
                Rst = Ren - Ndsp + 1 : Kst = Rst
                DrwPntFig.Show()
                DrwPntfig.MyGraph()
            Case 8
                CalItchim()   ' 一目均衡表の計算
                DrwIchimoku.Show()
                DrwIchimoku.MyGraph()
            Case 9
                Call ClPsyc()
                DrwPsycol.Show()
                DrwPsycol.MyGraph()
            Case 10
                Dtmp = Dmov
                Call CalMomentum() 'モメンタムの計算
                DrwMomentum.Show()
                DrwMomentum.MyGraph()
            Case 11
                Call CalROC() 'Rate of Changeの計算
                DrwRateChange.Show()
                DrwRateChange.MyGraph()
            Case 12
                Call CALPCR() '％Ｒオシレーターの計算
                DrwPcROscil.Show()
                DrwPcROscil.MyGraph()
            Case 13
                Call CALRSI() 'Rate of Changeの計算
                DrwRelStrInd.Show()
                DrwRelStrInd.MyGraph()
            Case 14
                Call CalStoch() 'Stochasticsの計算
                DrwStochastics.Show()
                DrwStochastics.MyGraph()
            Case 15
                Dtmp = SMOV
                Call MOVMAV() '移動平均値と乖離率の計算
                For i = 1 To Nkab
                    SMAV(i) = MAV(i) : SMKR(i) = MKR(i)
                Next
                Dtmp = LMOV
                Call MOVMAV()

                '短期と長期の乖離率の差(balance)の計算
                For i = 1 To Nkab
                    If SMKR(i) = -9999 Or MKR(i) = -9999 Then
                        Bal(i) = -9999
                    Else
                        Bal(i) = MKR(i) - SMKR(i)
                    End If
                Next
                DrwKairisen.Show()
                DrwKairisen.MyGraph()
            Case 16
                Call CLMACD() 'ＭＡＣＤの計算
                DrwMACD.Show()
                DrwMACD.MyGraph()
            Case 17
                Call CalShinohara() '篠原レシオの計算
                DrwShinohara.Show()
                DrwShinohara.MyGraph()
            Case 18
                Call CALDMI() 'DirectionalMovementIndexの計算
                DrwDirMov.Show()
                DrwDirMov.MyGraph()
            Case 19
                Dmov = Dmv1
                Call CALRCI() ' ＲＣＩの計算
                For i = 1 To Nkab : Cr0(i) = Cor(i) : Next
                Dmov = Dmv2
                Call CALRCI()
                DrwRnkCorInd.Show()
                DrwRnkCorInd.MyGraph()
            Case 20
                Call CALVOL() 'VRの計算
                Call CALRSI() 'RISの計算
                DrwVolRatio.Show()
                DrwVolRatio.MyGraph()
            Case 21
                Call CALOBV()
                DrwOnBalVol.Show()
                DrwOnBalVol.MyGraph()
            Case 22
                Kst = 1 : Ken = Nkab
                Call TNTSPR() : Call CALSPR()
                Dtmp = SMOV
                Call MOVMAV()  '短期移動平均の計算
                For i = 1 To Nkab
                    t = MAV(i) : tt = MKR(i)
                    SMAV(i) = MAV(i) : SMKR(i) = MKR(i)
                Next
                Dtmp = LMOV
                Call MOVMAV()          '長期移動平均の計算
                DrwSpwave.Show()
                DrwSpwave.MyGraph()
        End Select
        Me.Close()
    End Sub

    Private Sub Button2_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Beep()
        End
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Beep() : Me.Close()
        mnuTechAnal.Show()
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Select Case Pknd
            Case 1
                Dim SelEnvelo As New SelEnvelope
                SelEnvelo.Show()
            Case 2
                Dim SelBollin As New SelBollin
                SelBollin.Show()
            Case 3
                Dim SelParabo As New SelParabo
                SelParabo.Show()
            Case 4
                Dim SelKagiasi As New SelKagiasi
                SelKagiasi.Show()
            Case 5
                Dim SelShinne As New SelShinne
                SelShinne.Show()
            Case 6
                Dim SelRenkou As New SelRenkou
                SelRenkou.Show()
            Case 7
                Dim SelPntfig As New SelPntfig
                SelPntfig.Show()
            Case 8
                Dim SelIchimoku As New SelIchimoku
                SelIchimoku.Show()
            Case 9
                Dim SelPsycol As New SelPsycol
                SelPsycol.Show()
            Case 10
                Dim SelMomentum As New SelMomentum
                SelMomentum.Show()
            Case 11
                Dim SelRateChange As New SelRateChange
                SelRateChange.Show()
            Case 12
                Dim SelPcROscil As New SelPcROscil
                SelPcROscil.Show()
            Case 13
                Dim SelRelStrInd As New SelRelStrInd
                SelRelStrInd.Show()
            Case 14
                Dim SelStochastics As New SelStochastics
                SelStochastics.Show()
            Case 15
                Dim SelKairisen As New SelKairisen
                SelKairisen.Show()
            Case 16
                Dim SelMACD As New SelMACD
                SelMACD.Show()
            Case 17
                Dim SelShinohara As New SelShinohara
                SelShinohara.Show()
            Case 18
                Dim SelDirMov As New SelDirMov
                SelDirMov.Show()
            Case 19
                Dim SelRnkCorInd As New SelRnkCorInd
                SelRnkCorInd.Show()
            Case 20
                Dim SelVolRatio As New SelVolRatio
                SelVolRatio.Show()
            Case 21
                Dim SelOnBalVol As New SelOnBalVol
                SelOnBalVol.Show()
            Case 22
                Dim SelSpwave As New SelSpwave
                SelSpwave.Show()
        End Select
        Me.Close()
    End Sub
End Class