﻿Public Class DrwIchimoku
    Dim Ylen As Integer
    Dim Ltr(3, 5), Ltr1, Ltr2(5) As String

    Private Sub DrwIchimoku_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Left = Screen.PrimaryScreen.Bounds.Left : Me.Width = Screen.PrimaryScreen.Bounds.Width
        Me.Top = Screen.PrimaryScreen.Bounds.Top : Me.Height = Screen.PrimaryScreen.Bounds.Height
        Me.Text = TIT
        Beep()

        Ltr(0, 0) = "株" : Ltr(0, 1) = "価"
        Ltr1 = "年　　月　　日"
        Ltr2(1) = "転換線" : Ltr2(2) = "基準線"
        Ltr2(3) = "先行スパ１" : Ltr2(4) = "先行スパ２" : Ltr2(5) = "遅行スパン"

        PB1lft = (Me.Width - Z5wid) / 2 : PB1wid = Z5wid : PB1top = (Me.Height - Z5hgt) / 2 : PB1hgt = Z5hgt

        Xcnt = Me.Width \ 2
        Button1.Width = 180 : Button1.Height = 30 : Button1.Top = PB1top + PB1hgt - 50 : Button1.Left = Xcnt + 210
        Button2.Width = 180 : Button2.Height = 30 : Button2.Top = PB1top + PB1hgt - 50 : Button2.Left = Xcnt - 390
        Button3.Width = 180 : Button3.Height = 30 : Button3.Top = PB1top + PB1hgt - 50 : Button3.Left = Xcnt - 190
        Button4.Width = 180 : Button4.Height = 30 : Button4.Top = PB1top + PB1hgt - 50 : Button4.Left = Xcnt + 10

        PB2wid = 755 : PB2lft = PB1lft + (PB1wid - PB2wid) \ 2 + 55 : PB2hgt = 430 : PB2top = PB1top + (PB1hgt - PB2hgt) \ 2 - 50

        TextBox1.Width = 65 : TextBox1.Height = 10 : TextBox1.Top = PB1top : TextBox1.Left = PB1lft + 175
        TextBox2.Width = 45 : TextBox2.Height = 10 : TextBox2.Top = PB1top : TextBox2.Left = PB1lft + 275
        TextBox3.Width = 45 : TextBox3.Height = 10 : TextBox3.Top = PB1top : TextBox3.Left = PB1lft + 358
        TextBox4.Width = 45 : TextBox4.Height = 10 : TextBox4.Top = PB1top : TextBox4.Left = PB1lft + 440
        TextBox5.Width = 45 : TextBox5.Height = 10 : TextBox5.Top = PB1top : TextBox5.Left = PB1lft + 520
        TextBox6.Width = 50 : TextBox6.Height = 10 : TextBox6.Top = PB1top : TextBox6.Left = PB1lft + 615

        Label1.Top = PB1top + 5 : Label1.Left = PB1lft + 150
        Label2.Top = PB1top + 5 : Label2.Left = PB1lft + 253
        Label3.Top = PB1top + 5 : Label3.Left = PB1lft + 330
        Label4.Top = PB1top + 5 : Label4.Left = PB1lft + 413
        Label5.Top = PB1top + 5 : Label5.Left = PB1lft + 495
        Label6.Top = PB1top + 5 : Label6.Left = PB1lft + 575
        Label10.Top = PB1top : Label10.Left = PB1lft : Label10.Text = Str(Cod) + " " + Mei

        HScrollBar1.Left = PB1lft + 110 : HScrollBar1.Width = 755 : HScrollBar1.Top = PB1top + 540
        Ylen = 450 : Yrat = 1 : Trat = 1
        Ndsp = 150
        Ken = Nkab : Kst = Ken - Ndsp + 1
        HScrollBar1.Maximum = Nkab + 9 : HScrollBar1.Minimum = Ndsp
        HScrollBar1.LargeChange = 20 : HScrollBar1.SmallChange = 2 : HScrollBar1.Value = Nkab

        Call MyGraph()
    End Sub

    Public Sub MyGraph()
        MNXALL() : SCALE4() '株価
        Ymin = Min : Ymax = Max : Yntv = Ntv : Yfxp = Fxp

        Call DrawEachGraph()
        n = Ken
        DISP_KAB()
    End Sub

    Private Sub EachCalculation()
        '+++++++++++++++++++++++++++++++++++++++++++++++++
        ' 各項目の最小・最大値の計算
        '+++++++++++++++++++++++++++++++++++++++++++++++++

        MNXALL() : SCALE4() '株価
        Ymin = Min : Ymax = Max : Yntv = Ntv : Yfxp = Fxp
    End Sub

    Private Sub MNXALL()
        '１画面に描画するグラフの最小・最大値を求める
        Min = 10 ^ 9 : Max = -Min
        For i = Kst To Ken
            If En(i) > 0 Then
                If Min > Lo(i) Then Min = Lo(i)
                If Max < Hi(i) Then Max = Hi(i)
            End If
            If Tnk(i) <> -9999 Then
                If Min > Tnk(i) Then Min = Tnk(i)
                If Max < Tnk(i) Then Max = Tnk(i)
            End If
            If Kjn(i) <> -9999 Then
                If Min > Kjn(i) Then Min = Kjn(i)
                If Max < Kjn(i) Then Max = Kjn(i)
            End If
            If SP1(i) <> -9999 Then
                If Min > SP1(i) Then Min = SP1(i)
                If Max < SP1(i) Then Max = SP1(i)
            End If
            If SP2(i) <> -9999 Then
                If Min > SP2(i) Then Min = SP2(i)
                If Max < SP2(i) Then Max = SP2(i)
            End If
            If TPN(i) <> -9999 Then
                If Min > TPN(i) Then Min = TPN(i)
                If Max < TPN(i) Then Max = TPN(i)
            End If
        Next
    End Sub

    Public Sub SCALE4()
        '--------------------------------------------------
        '終値のMINとMAXから描画用MIN,MAX,NTV,TIC,FXPを求める
        '--------------------------------------------------
        ' MIN : 最小値         (in)
        ' MAX : 最大値         (in)
        ' NTV : 目盛り間隔     (out)
        ' TIC : 細目盛り       (out)
        ' FXP : 小数点以下桁数 (out)
        '--------------------------------------------------
        t = (Max - Min) / 20
        TIC = 10 ^ Int(Math.Log(t) / Math.Log(10))
        t = t / TIC
        If t >= 5 Then
            TIC = 5 * TIC
        ElseIf t >= 2 Then
            TIC = 2 * TIC
        End If
        Ntv = 5 * TIC
        Fxp = 0
        Do Until Math.Abs(Int(Ntv * 10 ^ Fxp + 0.5) - Ntv * 10 ^ Fxp) < 0.0001
            Fxp = Fxp + 1
        Loop
        Min = Ntv * Int(Min / Ntv)
        Max = Ntv * Int(Max / Ntv + 0.9999)
    End Sub

    Public Sub DrawEachGraph() '１画面ごとのグラフ描画
        Dim g As Graphics = Me.CreateGraphics()

        Call GraNam() 'グラフ名の記載

        Call GraWhole() '画面全体領域の決定

        Call XaxSec() ' 縦方向の仕切り線の描画（Ｘ軸の仕切り線）

        Call GraRosoku() ' ローソク足画面の描画

        '++++++++++
        t0 = PB1lft + 120 : t1 = PB1top + 30
        g.DrawLine(Pens.Blue, t0, t1, t0 + 45, t1)
        g.DrawString(Ltr2(1), FntR09, BrBlu, PB1lft + 167, PB1top + 25)
        TextBox7.Width = 45 : TextBox7.Height = 10
        TextBox7.Top = PB1top + 23 : TextBox7.Left = PB1lft + 208

        t0 = PB1lft + 260 : t1 = PB1top + 30
        g.DrawLine(Pens.Red, t0, t1, t0 + 45, t1)
        g.DrawString(Ltr2(2), FntR09, BrRed, PB1lft + 305, PB1top + 25)
        TextBox8.Width = 45 : TextBox8.Height = 10
        TextBox8.Top = PB1top + 23 : TextBox8.Left = PB1lft + 348

        Dim Dotpen1 As New Pen(Color.Tomato)
        dotpen1.DashStyle = Drawing2D.DashStyle.Dash
        t0 = PB1lft + 400 : t1 = PB1top + 30
        g.DrawLine(Dotpen1, t0, t1, t0 + 45, t1)
        g.DrawString(Ltr2(3), FntR09, Brushes.Tomato, PB1lft + 445, PB1top + 25)
        TextBox9.Width = 45 : TextBox9.Height = 10
        TextBox9.Top = PB1top + 23 : TextBox9.Left = PB1lft + 505

        Dim Dotpen2 As New Pen(Color.Green)
        dotpen2.DashStyle = Drawing2D.DashStyle.Dash
        t0 = PB1lft + 560 : t1 = PB1top + 30
        g.DrawLine(Dotpen2, t0, t1, t0 + 45, t1)
        g.DrawString(Ltr2(4), FntR09, BrGrn, PB1lft + 605, PB1top + 25)
        TextBox10.Width = 45 : TextBox10.Height = 10
        TextBox10.Top = PB1top + 23 : TextBox10.Left = PB1lft + 665

        Dim Dotpen3 As New Pen(Color.Violet)
        dotpen3.DashStyle = Drawing2D.DashStyle.Dash
        t0 = PB1lft + 717 : t1 = PB1top + 30
        g.DrawLine(Dotpen3, t0, t1, t0 + 45, t1)
        g.DrawString(Ltr2(5), FntR09, Brushes.Tomato, PB1lft + 760, PB1top + 25)
        TextBox11.Width = 45 : TextBox11.Height = 10
        TextBox11.Top = PB1top + 23 : TextBox11.Left = PB1lft + 820
    End Sub

    Public Sub GraNam()
        '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        ' グラフ名の記載
        '+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        Dim g As Graphics = Me.CreateGraphics()

        x1 = PB2lft : x2 = PB2lft + PB2wid
        g.DrawString(Ltr(0, 0), FntB09, BrBlk, PB1lft + 20, PB1top + 150)
        g.DrawString(Ltr(0, 1), FntB09, BrBlk, PB1lft + 20, PB1top + 350)
        g.DrawString("立　会　年　月　日", FntB09, BrBlk, PB1lft + 430, PB1top + 510)
    End Sub
    Public Sub GraWhole()
        '画面全体領域の決定
        Ax0 = PB2lft : Ax1 = PB2wid
        Ay0 = PB2top + PB2hgt : Ay1 = PB2top
        '++++++++++++++++++++++++++++++++++++
        Alft = Ax0 'グラフ全体の左端位置
        Awid = Ax1 'グラフ全体の横幅
        Atop = Ay1 'グラフ全体の上端位置
        Ahgt = Ay0 'グラフ全体の縦幅
    End Sub

    Public Sub XaxSec()
        '++++++++++++++++++++++++++++++++++++++++++++++
        ' 縦方向の仕切り線の描画（Ｘ軸の仕切り線）
        '++++++++++++++++++++++++++++++++++++++++++++++
        Dim g As Graphics = Me.CreateGraphics()
        '**********縦仕切線と年月を描画***********
        Xs0 = Alft : Xs1 = Alft + Awid
        Xw0 = Kst - 1 : Xw1 = Ken + 1
        Ys0 = Ahgt : Ys1 = Atop
        Yw0 = Ys0 : Yw1 = Ys1 : WSCOEF()
        Dx = 5 : Dy = (Ys0 - Ys1)
        dx0 = Xs0 : dx1 = Xs1 : dy1 = Atop : dy0 = PB2top + Ahgt
        dlt = Awid / (Ndsp + 1)
        Yr0 = -1 : Mo0 = 0
        For Xw = Kst To Ken
            Yr = Int(Dt(Xw) / 10000) : Mo = Int((Dt(Xw) - 10000 * Yr) / 100)
            If Mo0 <> Mo Then
                Mo0 = Mo
                Yw = Ay0 : WLDSCR() : t0 = Xs : t1 = Ys
                Yw = Ay1 : WLDSCR()
                g.DrawLine(myWht, Xs, Ys, t0, t1)
                g.DrawString(Mo0, FntR09, BrBlk, Xs - 6, t1 + 5)
                If Yr0 <> Yr Then
                    Yr0 = Yr
                    g.DrawString(2000 + Yr0, FntR09, BrBlk, Xs - 8, t1 + 20)
                End If
            End If
        Next
    End Sub

    Public Sub GraRosoku()
        Dim g As Graphics = Me.CreateGraphics()
        Dim Dotpen1 As New Pen(Color.Tomato)
        Dim Dotpen2 As New Pen(Color.Green)
        Dim Dotpen3 As New Pen(Color.Violet)
        Dim st0, hi0, lo0, en0 As Single
        Dotpen1.DashStyle = Drawing2D.DashStyle.DashDot
        Dotpen2.DashStyle = Drawing2D.DashStyle.Dash
        Dotpen3.DashStyle = Drawing2D.DashStyle.Dash
        'dotpen1.Width = 5
        '+++++++++++++++画面+++++++++++++++++++
        Xw0 = Kst - 1 : Xw1 = Ken + 1
        Yw0 = Ymin : Yw1 = Ymax
        Dy = Yunt * Yrat
        WSCOEF() ': Xs9 = Xs1
        '++++++++++横仕切線と対応株価を描画+++++++++++++
        For Yw = Ymin + Yntv To Ymax Step Yntv
            Xw = Xw0 : WLDSCR() : t0 = Xs : t1 = Ys
            Xw = Xw1 : WLDSCR()
            g.DrawLine(myWht, Xs, Ys, t0, t1)
            t = Int(Str(Yw).Length())
            g.DrawString(Yw, FntR09, BrBlk, t0 - t * 7, t1 - 10)
        Next
        '++++++++++ローソク足描画++++++++++++++++++++++
        For Xw = Kst To Ken
            t = Dt(Xw)
            Yw = St(Xw) : WLDSCR() : st0 = Ys
            Yw = En(Xw) : WLDSCR() : en0 = Ys
            Yw = Hi(Xw) : WLDSCR() : hi0 = Ys
            Yw = Lo(Xw) : WLDSCR() : lo0 = Ys
            If st0 < en0 Then
                g.FillRectangle(Brushes.Blue, Xs - 1, st0, 3, en0 - st0)
                g.DrawLine(Pens.Blue, Xs, hi0, Xs, lo0)
            ElseIf st0 > en0 Then
                g.FillRectangle(Brushes.Red, Xs - 1, en0, 3, st0 - en0)
                g.DrawLine(Pens.Red, Xs, hi0, Xs, lo0)
            Else
                Try
                    g.DrawLine(Pens.DarkCyan, Xs - 1, st0, Xs + 1, st0)
                    g.DrawLine(Pens.DarkCyan, Xs, hi0, Xs, lo0)
                Catch ex As Exception
                    Exit For
                End Try
            End If
        Next
        ' ++++++++++++++++++++++++++++転換線の描画
        ind = 0
        For Xw = Kst To Ken
            If Tnk(Xw) <> -9999 Then
                If ind = 0 Then
                    ind = 1 : Yw = Tnk(Xw) : WLDSCR()
                    Try
                        g.FillRectangle(BrBlu, Xs, Ys, 1, 1)
                        t0 = Xs : t1 = Ys
                    Catch ex As Exception
                        Exit For
                    End Try
                Else
                    Yw = Tnk(Xw) : WLDSCR()
                    g.DrawLine(myBlu, t0, t1, Xs, Ys)
                    t0 = Xs : t1 = Ys : ind = 1
                End If
            End If
        Next
        '+++++++++++++++++++++++++++++++++++ 基準線の描画
        ind = 0
        For Xw = Kst To Ken
            If Kjn(Xw) <> -9999 Then
                If ind = 0 Then
                    ind = 1 : Yw = Kjn(Xw) : WLDSCR()
                    Try
                        g.FillRectangle(BrRed, Xs, Ys, 1, 1)
                        t0 = Xs : t1 = Ys
                    Catch ex As Exception
                        Exit For
                    End Try
                Else
                    Yw = Kjn(Xw) : WLDSCR()
                    g.DrawLine(myRed, t0, t1, Xs, Ys)
                    t0 = Xs : t1 = Ys : ind = 1
                End If
            End If
        Next
        '++++++++++++++++++++++++++++++++ 先行スパン１の描画
        ind = 0
        For Xw = Kst To Ken
            If SP1(Xw) <> -9999 Then
                If ind = 0 Then
                    ind = 1 : Yw = SP1(Xw) : WLDSCR()
                    Try
                        g.FillRectangle(BrBlu, Xs, Ys, 1, 1)
                        t0 = Xs : t1 = Ys
                    Catch ex As Exception
                        Exit For
                    End Try
                Else
                    Yw = SP1(Xw) : WLDSCR()
                    g.DrawLine(Dotpen1, t0, t1, Xs, Ys)
                    t0 = Xs : t1 = Ys
                End If
            End If
        Next
        '++++++++++++++++++++++++++++++ 先行スパン２の描画
        ind = 0
        For Xw = Kst To Ken
            If SP2(Xw) <> -9999 Then
                If ind = 0 Then
                    ind = 1 : Yw = SP2(Xw) : WLDSCR()
                    Try
                        g.FillRectangle(BrGrn, Xs, Ys, 1, 1)
                        t0 = Xs : t1 = Ys
                    Catch ex As Exception
                        Exit For
                    End Try
                Else
                    Yw = SP2(Xw) : WLDSCR()
                    g.DrawLine(Dotpen2, t0, t1, Xs, Ys)
                    t0 = Xs : t1 = Ys
                End If
            End If
        Next
        '++++++++++++++++++++++++++++++++++ 遅行スパンの描画
        ind = 0
        For Xw = Kst To Ken
            If TPN(Xw) <> -9999 Then
                If ind = 0 Then
                    ind = 1 : Yw = TPN(Xw) : WLDSCR()
                    Try
                        g.FillRectangle(BrRed, Xs, Ys, 1, 1)
                        t0 = Xs : t1 = Ys
                    Catch ex As Exception
                        Exit For
                    End Try
                Else
                    Yw = TPN(Xw) : WLDSCR()
                    g.DrawLine(Dotpen3, t0, t1, Xs, Ys)
                    t0 = Xs : t1 = Ys
                End If
            End If
        Next
        '++++++++++外枠を描画
        Xw = Kst - 1 : Yw = Ymax : WLDSCR() : t0 = Xs : t1 = Ys
        Xw = Ken + 1 : Yw = Ymin : WLDSCR()
        g.DrawRectangle(myBlk, t0, t1, Xs - t0, Ys - t1)
    End Sub

    Public Sub WSCOEF()
        'WORLD座標からSCREEN座標への変換係数の計算
        Xtrn = (Xs1 - Xs0) / (Xw1 - Xw0)
        If Yw1 = Yw0 Then Stop
        Ytrn = (Ys1 - Ys0) / (Yw1 - Yw0)
    End Sub

    Public Sub WLDSCR()
        '===============================
        ' Ｗ→Ｓ変換
        '-------------------------------
        ' XS0  : Ｘ軸最小Ｓ座標値 (in)
        ' YS0  : Ｙ軸最小Ｓ座標値 (in)
        ' XW0  : Ｘ軸最小Ｗ座標値 (in)
        ' YW0  : Ｙ軸最小Ｗ座標値 (in)
        ' XTRN : Ｘ座標変換係数   (in)
        ' YTRN : Ｙ座標変換係数   (in)
        ' XW   : ＸのＷ座標値     (in)
        ' YW   : ＹのＷ座標値     (in)
        ' XS   : ＸのＳ座標値     (out)
        ' YS   : ＹのＳ座標値     (out)
        '-------------------------------
        Xs = Xs0 + Xtrn * (Xw - Xw0)
        Ys = Ys0 + Ytrn * (Yw - Yw0)
        'If YS <= 0 Then Stop
    End Sub

    Private Sub DISP_KAB()
        Dim YY, MM, DD As Single
        If n > 0 And Kst <= n And n <= Ken Then
            YY = Dt(n) \ 10000 : ss = FNNUM(2000 + YY)
            MM = (Dt(n) - 10000 * YY) \ 100 : ss = ss + "/" + Microsoft.VisualBasic.Right("0" + FNNUM(MM), 2)
            DD = Dt(n) - 10000 * YY - 100 * MM
            ss = ss + "/" + Microsoft.VisualBasic.Right("0" + FNNUM(DD), 2)

            TextBox1.Text = ss
            TextBox2.Text = St(n)
            TextBox3.Text = Hi(n)
            TextBox4.Text = Lo(n)
            TextBox5.Text = En(n)
            TextBox6.Text = Dk(n)
            TextBox7.Text = Format(Tnk(n), "#####.0")
            TextBox8.Text = Format(Kjn(n), "#####.0")
            TextBox9.Text = Format(SP1(n), "#####.0")
            TextBox10.Text = Format(SP2(n), "#####.0")
            If TPN(n) = -9999 Then
                TextBox11.Text = " -----"
            Else
                TextBox11.Text = Format(TPN(n), "#####.0")
            End If
        End If
    End Sub

    Private Sub HScrollBar1_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles HScrollBar1.Scroll
        '+++++++++++++++++++++++++++++++++++++++++
        ' HScrollBar1を動かして株価画面を移動する
        '+++++++++++++++++++++++++++++++++++++++++
        Dim g As Graphics = Me.CreateGraphics()

        g.Clear(SystemColors.ActiveBorder)

        EachCalculation() '各グラフの描画パラメタの計算

        DrawEachGraph() '１画面ごとのグラフ描画

        Ken = e.NewValue : Kst = Ken - Ndsp + 1
        n = Ken
        DISP_KAB()
    End Sub

    Private Sub PictureBox1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Me.MouseMove
        '++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        ' マウスを動かしてPictureBox上の株価画面上の位置を決める
        '++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        x = e.X : y = e.Y
        If dy1 <= y And y <= dy0 Then
            If x > dx1 Then
                n = Ken
            ElseIf x < dx0 Then
                n = Kst
            Else
                n = Kst + Int((x - dx0) / dlt) - 1
            End If
        ElseIf x < dx0 Then
            n = Kst
        Else
            n = Ken
        End If
        Call DISP_KAB()
    End Sub

    Public Function FNNUM(ByVal T) As Single
        '---------------------------------
        '数値を文字型に変換
        '---------------------------------
        t0 = Mid(Str(T), 2)
        If Math.Abs(T) < 1 Then
            If T < 0 Then FNNUM = "-0." + t0 Else FNNUM = "0." + t0
        Else
            If T < 0 Then FNNUM = "-" + t0 Else FNNUM = t0
        End If
    End Function

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Me.Close()
        Napp = Napp + 1 : If Napp > Nmei Then Napp = 1
        Meigara.Show()
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Beep()
        End
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Beep() : Me.Close()
        mnuTechAnal.Show()
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Me.Close()
        SelIchimoku.Show()
    End Sub
End Class
